Bug 1386538 - pmap_signin event fails to update brickinfo->signed_in flag
Summary: pmap_signin event fails to update brickinfo->signed_in flag
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: glusterd
Version: rhgs-3.2
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
: RHGS 3.2.0
Assignee: Atin Mukherjee
QA Contact: Byreddy
URL:
Whiteboard:
Depends On: 1385575 1386338
Blocks: 1351528
TreeView+ depends on / blocked
 
Reported: 2016-10-19 08:31 UTC by Atin Mukherjee
Modified: 2017-03-23 06:12 UTC (History)
5 users (show)

Fixed In Version: glusterfs-3.8.4-3
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1386338
Environment:
Last Closed: 2017-03-23 06:12:48 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description Atin Mukherjee 2016-10-19 08:31:58 UTC
+++ This bug was initially created as a clone of Bug #1386338 +++

+++ This bug was initially created as a clone of Bug #1385575 +++

Description of problem:

While testing gluster get-state CLI, we figured out that brickinfo->signed_in field of a given brick of a volume is marked as false even if the pmap_signin has successfully happened. 

Version-Release number of selected component (if applicable):
mainline

How reproducible:
always

Steps to Reproduce:
1.
2.
3.

Actual results:


Expected results:


Additional info:

--- Additional comment from Worker Ant on 2016-10-17 06:46:22 EDT ---

REVIEW: http://review.gluster.org/15655 (glusterd: set the brickinfo->port before spawning the bricks) posted (#1) for review on master by Atin Mukherjee (amukherj@redhat.com)

--- Additional comment from Worker Ant on 2016-10-18 10:16:21 EDT ---

COMMIT: http://review.gluster.org/15655 committed in master by Jeff Darcy (jdarcy@redhat.com) 
------
commit bac42476a14a16089e7185c7a250dfae43be6106
Author: Atin Mukherjee <amukherj@redhat.com>
Date:   Mon Oct 17 16:08:41 2016 +0530

    glusterd: set the brickinfo->port before spawning the bricks
    
    As of now, when glusterd spawns a brick process, post spawning, the brickinfo's
    port is set. The side effect of this is it opens up an window where the
    pmap_signin event can be initiated by the brick to glusterd and glusterd fails
    to update signed_in flag since the brickinfo port is still 0 and the comparison
    of port and brickinfo->port fails.
    
    As a solution, set the brickinfo->port post pmap_registry_alloc and if the brick
    spawn fails reset it to 0. This logic applies for rdma port too.
    
    Change-Id: I00a13d4c6d6809ebd19a972aa13e71ee5eac7e35
    BUG: 1385575
    Signed-off-by: Atin Mukherjee <amukherj@redhat.com>
    Reviewed-on: http://review.gluster.org/15655
    Smoke: Gluster Build System <jenkins@build.gluster.org>
    NetBSD-regression: NetBSD Build System <jenkins@build.gluster.org>
    CentOS-regression: Gluster Build System <jenkins@build.gluster.org>
    Reviewed-by: Samikshan Bairagya <samikshan@gmail.com>
    Reviewed-by: Jeff Darcy <jdarcy@redhat.com>

--- Additional comment from Worker Ant on 2016-10-19 04:30:59 EDT ---

REVIEW: http://review.gluster.org/15679 (glusterd: set the brickinfo->port before spawning the bricks) posted (#1) for review on release-3.9 by Atin Mukherjee (amukherj@redhat.com)

Comment 2 Atin Mukherjee 2016-10-19 08:34:17 UTC
an upstream mainline patch http://review.gluster.org/15679 is already merged. Upstream 3.9 patch http://review.gluster.org/#/c/15679 posted for review.

Comment 4 Atin Mukherjee 2016-10-21 09:24:48 UTC
upstream mainline : http://review.gluster.org/15655
upstream 3.9 : http://review.gluster.org/15679
downstream patch : https://code.engineering.redhat.com/gerrit/87882

Comment 7 Byreddy 2016-10-26 09:29:37 UTC
Verified this bug using the build 3.8.4-3, Fix is working good, i am seeing brick signed entry set to true when brick process is running.


Volume1.Brick1.port: 49152
Volume1.Brick1.rdma_port: 0
Volume1.Brick1.status: Started
Volume1.Brick1.signedin: True


Moving to verified state.

Comment 9 errata-xmlrpc 2017-03-23 06:12:48 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.